# -*- mode: rpm-spec; coding: utf-8 -*-
%define base_name      dbus

%define version        1.0.2
%define source_name    %base_name
%define source_version %version
%define release        alt3

%def_disable static

%define dbus_user      messagebus
%define dbus_group     messagebus

%define system_socket_dir /var/run/dbus
%define session_socket_dir %system_socket_dir/users

%define system_socket %system_socket_dir/system_bus_socket

Name:    %base_name
Version: %version
Release: %release

Summary: D-BUS is a simple IPC framework based on messages.
Summary(ru_RU.UTF-8): D-BUS это простая среда межпроцессного взаимодействия, построенная на сообщениях
License: GPL or Academic Free License
Group: System/Servers
Url: http://www.freedesktop.org/Software/dbus

Packager: Igor Zubkov <icesik@altlinux.org>

Requires: lib%name = %version, shadow-utils
# Only new, fresh, carefully selected and 'you-cant-live-without' build requirements
# buildreq, hmm, well, you know...
# Automatically added by buildreq on Tue Oct 31 2006
#BuildRequires: doxygen gcc-c++ imake libexpat-devel libSM-devel libX11-devel linux-libc-headers packages-info-i18n-common xmlto xorg-cf-files
BuildRequires: doxygen gcc-c++ imake libexpat-devel libSM-devel libX11-devel xmlto xorg-cf-files

%if_enabled static
BuildRequires: glibc-devel-static
%endif

#BuildRequires: doxygen gcc-c++ gcc-fortran glibc-devel-static imake libexpat-devel libSM-devel libX11-devel linux-libc-headers packages-info-i18n-common xmlto xorg-cf-files
#BuildRequires: doxygen fontconfig gcc-g77 gcc-c++ gcc-java glibc-devel-static imake libexpat-devel libgtk+2-devel libqt3-devel libqt4-devel libXt-devel linux-libc-headers mono-tools python-dev python-module-Pyrex python-modules python-modules-compiler python-modules-encodings time xmlto xorg-cf-files
#BuildRequires: doxygen xmlto libexpat-devel libgtk+2-devel gcc-c++ /proc

Source0: http://freedesktop.org/Software/dbus/%name-%version.tar.gz
Source1: dbus-daemon.sh

#Source1: http://freedesktop.org/Software/dbus/%name-docs.tar.bz2 
# (gb) 0.22-2mdk fix detection of moc path
#-------------------------------------------

Patch2:  dbus-0.61-qt3libs.patch
Patch3: dbus-0.34-altify_init_script.patch
Patch4: dbus-0.22-alt-gcj-parallel-make.patch
Patch5: dbus-0.22-alt-mono-parallel-make.patch
Patch6: dbus-0.23-alt-gcj-fPIC.patch

Patch7: dbus-1.0.1-altify_init_script.patch

%description
D-BUS is a system for low-latency, low-overhead, easy to use interprocess
communication (IPC). In more detail:

  o D-BUS is low-latency because it is designed to avoid round trips and
    allow asynchronous operation, much like the X protocol.

  o D-BUS is low-overhead because it uses a binary protocol, and does not
    have to convert to and from a text format such as XML. Because D-BUS is
    intended for potentially high-resolution same-machine IPC, not primarily
    for Internet IPC, this is an interesting optimization.

  o D-BUS is easy to use because it works in terms of messages rather than
    byte streams, and automatically handles a lot of the hard IPC issues.
    Also, the D-BUS library is designed to be wrapped in a way that lets
    developers use their framework's existing object/type system, rather
    than learning a new one specifically for IPC.

This package contains D-BUS daemon and system utilities.

%description -l ru_RU.UTF-8
D-BUS - это система для межпроцессного взаимодействия (IPC), которое имело бы
маленькое время реакции (low-latency), не требовало бы большого количества
ресурсов и было бы легким в использовании. Более подробно:

  o D-BUS имеет маленькое время реакции, т.к. ее строение позволяет избежать
    циклов ожидания и выполнять операции асинхронно, подобно тому, как устроен
    X протокол

  o D-BUS экономно относится к русурсам, т.к. в ее основе лежит двоичный протокол,
    и нет нужды преобразовывать данные из/в текстовый формат, н-р, XML. Поскольку
    D-BUS предназначен для высокоскоростного взаимодействия в пределах одного
    компьютера, а не в Internet, это является эффективной оптимизацией.

  o D-BUS легка в использовании, т.к. предполагает работу в терминах сообщений,
    а не потоков байтов, и автоматически выполняет большую часть сложных задач
    IPC. Кроме того, библиотека D-BUS специально написана так, чтобы конечные
    пользователи работали не с самой библиотекой, а с ее обертками, подогнанными
    под конкретные прикладные среды программирования.

В этом пакете находятся сервер и системные утилиты D-BUS.

%package tools
Summary: D-BUS user helper tools
Summary(ru_RU.UTF-8): Пользовательские утилиты D-BUS
Group: Monitoring
Provides: dbus-userhelpers = %version-%release
Obsoletes: dbus-userhelpers

%description tools
D-BUS is a system for low-latency, low-overhead, easy to use interprocess
communication (IPC). In more detail:

  o D-BUS is low-latency because it is designed to avoid round trips and
    allow asynchronous operation, much like the X protocol.

  o D-BUS is low-overhead because it uses a binary protocol, and does not
    have to convert to and from a text format such as XML. Because D-BUS is
    intended for potentially high-resolution same-machine IPC, not primarily
    for Internet IPC, this is an interesting optimization.

  o D-BUS is easy to use because it works in terms of messages rather than
    byte streams, and automatically handles a lot of the hard IPC issues.
    Also, the D-BUS library is designed to be wrapped in a way that lets
    developers use their framework's existing object/type system, rather
    than learning a new one specifically for IPC.

This package includes user tools for launching D-BUS service on session startup.

%description -l ru_RU.UTF-8 tools
D-BUS - это система для межпроцессного взаимодействия (IPC), которое имело бы
маленькое время реакции (low-latency), не требовало бы большого количества
ресурсов и было бы легким в использовании. Более подробно:

  o D-BUS имеет маленькое время реакции, т.к. ее строение позволяет избежать
    циклов ожидания и выполнять операции асинхронно, подобно тому, как устроен
    X протокол

  o D-BUS экономно относится к русурсам, т.к. в ее основе лежит двоичный протокол,
    и нет нужды преобразовывать данные из/в текстовый формат, н-р, XML. Поскольку
    D-BUS предназначен для высокоскоростного взаимодействия в пределах одного
    компьютера, а не в Internet, это является эффективной оптимизацией.

  o D-BUS легка в использовании, т.к. предполагает работу в терминах сообщений,
    а не потоков байтов, и автоматически выполняет большую часть сложных задач
    IPC. Кроме того, библиотека D-BUS специально написана так, чтобы конечные
    пользователи работали не с самой библиотекой, а с ее обертками, подогнанными
    под конкретные прикладные среды программирования.

В данный пакет включены пользовательские утилиты для запуска сервиса D-BUS при старте сессии.

%package tools-gui
Summary:  D-BUS user helper tools
Group: Monitoring

%description tools-gui
D-BUS is a system for low-latency, low-overhead, easy to use interprocess
communication (IPC). In more detail:

  o D-BUS is low-latency because it is designed to avoid round trips and
    allow asynchronous operation, much like the X protocol.

  o D-BUS is low-overhead because it uses a binary protocol, and does not
    have to convert to and from a text format such as XML. Because D-BUS is
    intended for potentially high-resolution same-machine IPC, not primarily
    for Internet IPC, this is an interesting optimization.

  o D-BUS is easy to use because it works in terms of messages rather than
    byte streams, and automatically handles a lot of the hard IPC issues.
    Also, the D-BUS library is designed to be wrapped in a way that lets
    developers use their framework's existing object/type system, rather
    than learning a new one specifically for IPC.

This package includes user tools for launching D-BUS service on session startup.

%package -n lib%name
Summary: D-BUS shared libraries
Group: System/Libraries

%description -n lib%name
D-BUS is a system for low-latency, low-overhead, easy to use interprocess
communication (IPC). In more detail:

  o D-BUS is low-latency because it is designed to avoid round trips and
    allow asynchronous operation, much like the X protocol.

  o D-BUS is low-overhead because it uses a binary protocol, and does not
    have to convert to and from a text format such as XML. Because D-BUS is
    intended for potentially high-resolution same-machine IPC, not primarily
    for Internet IPC, this is an interesting optimization.

  o D-BUS is easy to use because it works in terms of messages rather than
    byte streams, and automatically handles a lot of the hard IPC issues.
    Also, the D-BUS library is designed to be wrapped in a way that lets
    developers use their framework's existing object/type system, rather
    than learning a new one specifically for IPC.

This package contains D-BUS shared libraries.

%description -n lib%name -l ru_RU.UTF-8
D-BUS - это система для межпроцессного взаимодействия (IPC), которое имело бы
маленькое время реакции (low-latency), не требовало бы большого количества
ресурсов и было бы легким в использовании. Более подробно:

  o D-BUS имеет маленькое время реакции, т.к. ее строение позволяет избежать
    циклов ожидания и выполнять операции асинхронно, подобно тому, как устроен
    X протокол

  o D-BUS экономно относится к русурсам, т.к. в ее основе лежит двоичный протокол,
    и нет нужды преобразовывать данные из/в текстовый формат, н-р, XML. Поскольку
    D-BUS предназначен для высокоскоростного взаимодействия в пределах одного
    компьютера, а не в Internet, это является эффективной оптимизацией.

  o D-BUS легка в использовании, т.к. предполагает работу в терминах сообщений,
    а не потоков байтов, и автоматически выполняет большую часть сложных задач
    IPC. Кроме того, библиотека D-BUS специально написана так, чтобы конечные
    пользователи работали не с самой библиотекой, а с ее обертками, подогнанными
    под конкретные прикладные среды программирования.

В этом пакете находятся разделяемые библиотеки D-BUS.

%package -n lib%name-devel
Summary: D-BUS development files
Group: Development/C
Requires: lib%name = %version-%release
%description -n lib%name-devel
D-BUS is a system for low-latency, low-overhead, easy to use interprocess
communication (IPC). In more detail:

  o D-BUS is low-latency because it is designed to avoid round trips and
    allow asynchronous operation, much like the X protocol.

  o D-BUS is low-overhead because it uses a binary protocol, and does not
    have to convert to and from a text format such as XML. Because D-BUS is
    intended for potentially high-resolution same-machine IPC, not primarily
    for Internet IPC, this is an interesting optimization.

  o D-BUS is easy to use because it works in terms of messages rather than
    byte streams, and automatically handles a lot of the hard IPC issues.
    Also, the D-BUS library is designed to be wrapped in a way that lets
    developers use their framework's existing object/type system, rather
    than learning a new one specifically for IPC.

This package contains D-BUS development files (headers and libraries links).

%description -n lib%name-devel -l ru_RU.UTF-8
D-BUS - это система для межпроцессного взаимодействия (IPC), которое имело бы
маленькое время реакции (low-latency), не требовало бы большого количества
ресурсов и было бы легким в использовании. Более подробно:

  o D-BUS имеет маленькое время реакции, т.к. ее строение позволяет избежать
    циклов ожидания и выполнять операции асинхронно, подобно тому, как устроен
    X протокол

  o D-BUS экономно относится к русурсам, т.к. в ее основе лежит двоичный протокол,
    и нет нужды преобразовывать данные из/в текстовый формат, н-р, XML. Поскольку
    D-BUS предназначен для высокоскоростного взаимодействия в пределах одного
    компьютера, а не в Internet, это является эффективной оптимизацией.

  o D-BUS легка в использовании, т.к. предполагает работу в терминах сообщений,
    а не потоков байтов, и автоматически выполняет большую часть сложных задач
    IPC. Кроме того, библиотека D-BUS специально написана так, чтобы конечные
    пользователи работали не с самой библиотекой, а с ее обертками, подогнанными
    под конкретные прикладные среды программирования.

В этом пакете находятся файлы для разработки с использованием D-BUS (заголовочные
файлы и библиотеки).

%if_enabled static
%package -n  lib%name-devel-static
Summary: D-BUS static libraries
Group: Development/C
Requires: lib%name-devel = %version-%release

%description -n lib%name-devel-static
D-BUS is a system for low-latency, low-overhead, easy to use interprocess
communication (IPC). In more detail:

  o D-BUS is low-latency because it is designed to avoid round trips and
    allow asynchronous operation, much like the X protocol.

  o D-BUS is low-overhead because it uses a binary protocol, and does not
    have to convert to and from a text format such as XML. Because D-BUS is
    intended for potentially high-resolution same-machine IPC, not primarily
    for Internet IPC, this is an interesting optimization.

  o D-BUS is easy to use because it works in terms of messages rather than
    byte streams, and automatically handles a lot of the hard IPC issues.
    Also, the D-BUS library is designed to be wrapped in a way that lets
    developers use their framework's existing object/type system, rather
    than learning a new one specifically for IPC.

This package contains D-BUS static development libraries.

%description -n lib%name-devel-static -l ru_RU.UTF-8
D-BUS - это система для межпроцессного взаимодействия (IPC), которое имело бы
маленькое время реакции (low-latency), не требовало бы большого количества
ресурсов и было бы легким в использовании. Более подробно:

  o D-BUS имеет маленькое время реакции, т.к. ее строение позволяет избежать
    циклов ожидания и выполнять операции асинхронно, подобно тому, как устроен
    X протокол

  o D-BUS экономно относится к русурсам, т.к. в ее основе лежит двоичный протокол,
    и нет нужды преобразовывать данные из/в текстовый формат, н-р, XML. Поскольку
    D-BUS предназначен для высокоскоростного взаимодействия в пределах одного
    компьютера, а не в Internet, это является эффективной оптимизацией.

  o D-BUS легка в использовании, т.к. предполагает работу в терминах сообщений,
    а не потоков байтов, и автоматически выполняет большую часть сложных задач
    IPC. Кроме того, библиотека D-BUS специально написана так, чтобы конечные
    пользователи работали не с самой библиотекой, а с ее обертками, подогнанными
    под конкретные прикладные среды программирования.

В этом пакете находятся статические библиотеки разработки для D-BUS.
%endif

%undefine __libtoolize

%prep
%setup -q -n %source_name-%source_version
#patch2 -p1

# need update!!!
#patch3 -p1

#patch4 -p1
#patch5 -p1
#patch6 -p1
%patch7 -p1

%build
%__autoreconf

#### Build once with tests to make check
#configure \
#	--with-system-pid-file=%_var/run/messagebus.pid \
#	--enable-tests=yes \
#	--enable-verbose-mode=yes \
#	--enable-asserts=yes
#DBUS_VERBOSE=1 %make_build

#### Clean up and build again
#__make clean

%configure \
	--enable-dependency-tracking \
	--enable-xml-docs \
	--with-x \
	--enable-dnotify \
	--with-xml=expat \
	--enable-shared \
	%{subst_enable static} \
	--with-system-pid-file=%_var/run/messagebus.pid \
	--with-system-socket=%system_socket \
	--with-session-socket-dir=%session_socket_dir \
	--enable-doxygen-docs \
	--localstatedir=%_var \
	--disable-tests --disable-asserts

%make_build

doxygen Doxyfile

mv doc/api/html api

%install
%make_install DESTDIR=%buildroot install

mkdir -p %buildroot%system_socket_dir
mkdir -p %buildroot%session_socket_dir
chmod 1777 %buildroot%session_socket_dir

mkdir -p %buildroot%_localstatedir/dbus/

mkdir -p %buildroot%_sysconfdir/X11/profile.d/

install -p -m755 %_sourcedir/dbus-daemon.sh \
%buildroot%_sysconfdir/X11/profile.d/

%pre
/usr/sbin/groupadd -r -f %dbus_group 2> /dev/null ||:
/usr/sbin/useradd -r -n -g %dbus_group -d %system_socket_dir -s /dev/null \
	-c "D-Bus System User" %dbus_user 2> /dev/null ||:

%post
%post_service messagebus
%_bindir/dbus-uuidgen --ensure

%preun
%preun_service messagebus

%post -n lib%name
%post_ldconfig

%postun -n lib%name
%postun_ldconfig

%files
%dir %_sysconfdir/dbus-1/
%config(noreplace) %_sysconfdir/dbus-1/*.conf
%dir %_sysconfdir/dbus-1/system.d
%attr(755,root,root) %config(noreplace) %_initdir/messagebus
%_bindir/dbus-cleanup-sockets
%_bindir/dbus-daemon
%_man1dir/dbus-cleanup-sockets.*
%_man1dir/dbus-daemon.*
%_bindir/dbus-uuidgen
%_man1dir/dbus-uuidgen.*
%attr(0755,root,root) %dir %system_socket_dir
%attr(1777,root,root) %dir %session_socket_dir
%dir %_datadir/dbus-1/
%attr(-,root,root) %_datadir/dbus-1/services
%dir %_localstatedir/dbus/

%files tools
%_bindir/dbus-send
%_man1dir/dbus-send.*
%_bindir/dbus-monitor
%_man1dir/dbus-monitor.*

%files tools-gui
%config(noreplace) %_sysconfdir/X11/profile.d/*
%_bindir/dbus-launch
%_man1dir/dbus-launch.*

%files -n lib%name
%_libdir/libdbus-1.so.*

%files -n lib%name-devel
%doc doc/TODO doc/dbus-*.html doc/dbus-*.xml doc/dcop-howto.txt
%doc HACKING NEWS README AUTHORS
%doc api
%_libdir/libdbus-1.so
%dir %_includedir/dbus-1.0/dbus/
%_includedir/dbus-1.0/dbus/dbus*.h
%dir %_libdir/dbus-1.0/
%_libdir/dbus-1.0/
%_libdir/pkgconfig/dbus-1.pc

%if_enabled static
%files -n lib%name-devel-static
%_libdir/libdbus-1.a
%endif

%changelog
* Fri Apr 27 2007 Igor Zubkov <icesik@altlinux.org> 1.0.2-alt3
- Add X11 session script to dbus-tools-gui (closes #10079)

* Tue Apr 10 2007 Igor Zubkov <icesik@altlinux.org> 1.0.2-alt2
- clean up spec file
- clean up buildrequires
- shutup useradd and groupadd (closes #8760)
- own /etc/dbus-1/ and /usr/share/dbus-1/ (closes #10365)

* Thu Dec 14 2006 Igor Zubkov <icesik@altlinux.org> 1.0.2-alt1
- 1.0.1 -> 1.0.2 (security bug fix)
- patch dbus-1.0.1-pthread-holder-fix.patch merged in upstream
- CVE-2006-6107 (http://secunia.com/advisories/23373/)

* Mon Dec 04 2006 Igor Zubkov <icesik@altlinux.org> 1.0.1-alt4
- fix init script
- don't make tests

* Sun Nov 26 2006 Igor Zubkov <icesik@altlinux.org> 1.0.1-alt3
- add /var/lib/dbus/ to dbus package
- make tests

* Sun Nov 26 2006 Igor Zubkov <icesik@altlinux.org> 1.0.1-alt2
- update init script

* Sun Nov 26 2006 Igor Zubkov <icesik@altlinux.org> 1.0.1-alt1
- 0.94 -> 1.0.1
- dbus-send-do-not-close-shared-connection-thoenig-01.patch merged in upstream

* Sun Nov 26 2006 Igor Zubkov <icesik@altlinux.org> 0.94-alt2
- merge with Sisyphus dbus

* Sun Nov 26 2006 Igor Zubkov <icesik@altlinux.org> 0.94-alt1
- 0.62 -> 0.94 (aka 1.0 RC2)
- buildreq (also, remove /proc from BuildRequires)
- remove dbus-viewer from dbus-tools-gui (by upstream)
- add new tool -- dbus-uuidgen to dbus package
- remove ALL binding's (by upstream)

* Fri Nov 17 2006 Igor Zubkov <icesik@altlinux.org> 0.62-alt3
- fix build (try 2)

* Fri Nov 17 2006 Igor Zubkov <icesik@altlinux.org> 0.62-alt2
- disable mono bindings
- disable qt4 bindings
- add packager tag

* Tue Jun 20 2006 Anton Farygin <rider@altlinux.ru> 0.62-alt1
- new version

* Mon May 22 2006 Anton Farygin <rider@altlinux.ru> 0.61-alt3
- proc added to BuildReq (need for mono bindings)

* Fri May 19 2006 Anton Farygin <rider@altlinux.ru> 0.61-alt2
- fixed byild with gcc-4.1
- enabled mono bindings (thanks to sin@)

* Tue Apr 11 2006 Anton Farygin <rider@altlinux.ru> 0.61-alt1
- new version

* Wed Sep 07 2005 Anton Farygin <rider@altlinux.ru> 0.50-alt1
- new version

* Tue Aug 30 2005 Anton Farygin <rider@altlinux.ru> 0.36.2-alt1
- new version

* Fri Aug 26 2005 Anton Farygin <rider@altlinux.ru> 0.36.1-alt1
- new version

* Fri Aug 19 2005 Anton Farygin <rider@altlinux.ru> 0.35.2-alt1
- new version

* Wed Aug 17 2005 Anton Farygin <rider@altlinux.ru> 0.34-alt5
- start messagebus after dm

* Tue Aug 16 2005 Anton Farygin <rider@altlinux.ru> 0.34-alt4
- dbus-qt.h moved to libdbus-qt-devel

* Mon Aug 08 2005 Anton Farygin <rider@altlinux.ru> 0.34-alt3
- verbosing post-scripts
- disabled build for mono

* Wed Aug 03 2005 Anton Farygin <rider@altlinux.ru> 0.34-alt2
- requires fixed for devel packages (#7064)
- headers for dbus-qt moved to libdbus-qt-devel (#6311)

* Tue Jul 12 2005 Anton Farygin <rider@altlinux.ru> 0.34-alt1
- new version
- disabled mono for x86_64

* Fri May 13 2005 Anton Farygin <rider@altlinux.ru> 0.23.4-alt1
- updated to new version
- gui tools moved from dbus-tools to dbus-tools-gui

* Sun Feb 06 2005 Alexey Morozov <morozov@altlinux.org> 0.23-alt2
- Finally managed to compile Qt bindings!
  Some issues are unresolved though. Someone can take a look into
  qt/message.cpp and implement Message copy constructor and
  putting QVariant datatypes to dbus messages.

* Thu Jan 20 2005 Alexey Morozov <morozov@altlinux.org> 0.23-alt1
- New version (0.23)
- Patches from Mandrake are in mainstream now
- mono location workaround is applied for install section too
- -userhelpers subpackage is renamed to -tools as #5341 suggests
- python package is built against recent rpm-build-python specs and
  corresponding python-module-Pyrex

* Sat Jan 15 2005 Vital Khilko <vk@altlinux.ru> 0.22-alt2
- added patches from Mandrake Linux

* Tue Sep  7 2004 Alexey Morozov <morozov@altlinux.org> 0.22-alt1
- Initial build.
